SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 21:05'!
catalogue
 	| catalogue |
	catalogue := Dictionary new.
	catalogue add: (Association key: 1 value: 1).
	catalogue add: (Association key: 2 value: 2).
	^ catalogue.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:16'!
test01NewCartShouldBeEmpty
	| newCart aCatalogue|
	aCatalogue := Array new.
	newCart := Cart withCatalogue: aCatalogue .
	self assert: newCart listProducts = Bag new.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:49'!
test02CartShouldListProductAfterAdded
	| newCart  bag|
	newCart := Cart withCatalogue: self catalogue .	
		
	newCart add: 1.
	bag := newCart listProducts.
	self assert: (bag includes: 1 ).
	self assert: (bag size = 1 ).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:28'!
test02bQuantityShouldIncreaseInOne
	| newCart firstQuantity |
	newCart := Cart withCatalogue: self catalogue.
	firstQuantity := newCart quantityOf: 1.
	newCart add: 1.
	self assert: ((firstQuantity + 1) = (newCart quantityOf: 1)).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:48'!
testCannotAddProductNotInCatalogue
	| newCart |
	newCart := Cart withCatalogue: self catalogue.
	self should: [ newCart add:15 ] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText   = Cart invalidElementError ). self assert: ((newCart listProducts) isEmpty ) ].! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:52'!
testIfModifyListProductNotModifyCartProduct
	|bagToModify newCart |
	newCart := Cart withCatalogue: self catalogue .	
		
	newCart add: 1.
	bagToModify := newCart listProducts.
	bagToModify removeAll.
	self assert: ( newCart listProducts includes: 1 ).
	self assert: ( newCart listProducts size = 1 ).! !

Object subclass: #Cart
	instanceVariableNames: 'bag catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/27/2013 21:45'!
create
	^Cart new initialize.! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:42'!
invalidElementError
	^'elemento invalido'.! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:22'!
withCatalogue: aCatalogue
	|cart|
      cart  := Cart new.
	cart setCatalogue: aCatalogue.
	^ cart.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:42'!
add: aProduct
	(catalogue includes: aProduct ) ifFalse: [ Error signal: Cart invalidElementError ].
	bag add: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/27/2013 21:45'!
initialize
	bag := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 19:24'!
listProducts
	^ Bag newFrom:  bag.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 19:24'!
quantityOf: aProduct
	^bag occurrencesOf: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:23'!
setCatalogue: aCatalogue
	catalogue := aCatalogue.! !

Object subclass: #Cashier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Product
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Tarjeta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Venta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!
